// Export Pages ID Java Script for Adobe InDesign CS3. Version 1.8.2 Copyright (c) Jungle Software 2007.

#includepath "~/Jungle Software/Library"

#include "JS_CreativeSuiteLibrary.jsx"

const JS_EXPORT_PAGES_ID_PREFS_FILENAME = "Export Pages ID Prefs.txt";

const JS_PDF_STYLE_KEY = "PDFExport";
const JS_PDF_PRESET_NAME_KEY = "PDFPreset";
const JS_PS_STYLE_KEY = "PSExport";
const JS_PS_PRESET_NAME_KEY = "PSPreset";
const JS_DOCUMENT_OFFSET_PREFIX_KEY = "DocumentOffset";
const JS_REAL_NAME_PREFIX_KEY = "RealName";
const JS_CONTINUOUS_NUMBER_PREFIX_KEY = "ContinuousNumber";

// ================================ Export Preferences Resources ===================================

var JS_stylePanelID = "panel { text:'Export Style', alignChildren:'left',\
					emptyST:StaticText { text:''},\
					pdfGrp:Group { orientation:'row', alignChildren:'top', indent:15,\
						pdfStyle:Checkbox { text:'PDF' },\
						pdfPreset:DropDownList { alignment:'right' }\
					},\
					psGrp:Group { orientation:'row', alignChildren:'top', indent:15,\
						psStyle:Checkbox { text:'PS  ' },\
						psPreset:DropDownList { alignment:'right' }\
					}\
					}";
					
var JS_expNamePanelID = "panel { text:'Export File Names', alignChildren:'left',\
					emptyST:StaticText { text:''},\
					nameGrp:Group { orientation:'column', alignChildren:'top',\
						namePrfST:StaticText { text:'Page File Name Prefix', indent:15 },\
						offsetBtn:RadioButton { text:'Document Offset', indent:30 },\
						nameBtn:RadioButton { text:'Real Name', indent:30 },\
						contBtn:RadioButton { text:'Continuous Number', indent:30 },\
						nameConstST:StaticText { text:'User-defined Page File Name Part', indent:15 },\
						nameText:EditText { preferredSize:[260, 20], indent:30 }\
					}\
					}";

var JS_expFolderPanelID = "panel { text:'Export Folder Name', alignChildren:'right',\
					emptyST:StaticText { text:''},\
					folderText:EditText { preferredSize:[260, 20], indent:15 }\
					}";

var JS_rangePanelID = "panel { text:'Export Range', alignChildren:'left',\
					emptyST:StaticText { text:''},\
					rngGrp:Group { orientation:'row', alignChildren:'top', indent:15,\
						allBtn:RadioButton { text:'All' },\
						rngBtn:RadioButton { text:'Range' },\
						rngText:EditText { preferredSize:[160, 20] }\
					}\
					}";

function JS_SaveExportPagesPrefsID(JS_prefData, JS_prefFile) {

	if(JS_prefFile.open("write")) {
		
		JS_prefFile.writeln(JS_PDF_STYLE_KEY + JS_EQUAL_SIGN + JS_prefData.pdfStyle);
		JS_prefFile.writeln(JS_PDF_PRESET_NAME_KEY + JS_EQUAL_SIGN + JS_prefData.pdfPreset);		
		JS_prefFile.writeln(JS_PS_STYLE_KEY + JS_EQUAL_SIGN + JS_prefData.psStyle);		
		JS_prefFile.writeln(JS_PS_PRESET_NAME_KEY + JS_EQUAL_SIGN + JS_prefData.psPreset);		
		JS_prefFile.writeln(JS_DOCUMENT_OFFSET_PREFIX_KEY + JS_EQUAL_SIGN + JS_prefData.offsetPrefix);		
		JS_prefFile.writeln(JS_REAL_NAME_PREFIX_KEY + JS_EQUAL_SIGN + JS_prefData.namePrefix);		
		JS_prefFile.writeln(JS_CONTINUOUS_NUMBER_PREFIX_KEY + JS_EQUAL_SIGN + JS_prefData.contPrefix);		
		JS_prefFile.close();
	}
	else alert("JS_SaveExportPagesPrefsID" + JS_CARR_RETURN + "Can't open Preferences File for write operations...");

}

function JS_PadZerosID(JS_number, JS_totalLen) {
	
var JS_numStr = JS_number.toString();
var JS_numZeros = JS_totalLen - JS_numStr.length;
	
	if (JS_numZeros > 0) {
		
		for (var JS_indexI = 1; JS_indexI <= JS_numZeros; JS_indexI++) JS_numStr = "0" + JS_numStr; 
	} 
	return JS_numStr; 
} 

function JS_GetNamePrefixID(JS_prefData, JS_pageOffset, JS_pageName, JS_contIndex) {

var JS_semyRegExp = new RegExp(":","gi");

var JS_namePrefix;								
								
	if(JS_prefData.offsetPrefix) JS_namePrefix = JS_PadZerosID(JS_pageOffset + 1, 3);
	
	else {
									
		if(JS_prefData.namePrefix) {
									
			JS_namePrefix = new String(JS_pageName);
			JS_namePrefix = JS_namePrefix.replace(JS_semyRegExp, "_");
		}
		else JS_namePrefix = JS_PadZerosID(JS_contIndex + 1, 3);
	}
	return JS_namePrefix;
}

function main() {

var JS_nameRange = new Array();
var JS_offsetRange = new Array();
 
var JS_pdfPresNames = new Array();
var JS_psPresNames = new Array();

	if(app.documents.length) {
	
		var JS_prefFile = new File(JS_PREFERENCES_FOLDER + JS_FOLDER_SUFFIX + JS_EXPORT_PAGES_ID_PREFS_FILENAME);
	
		if(JS_prefFile.exists) {
		
			var JS_prefData = new Object;

			if(JS_prefFile.open("read")) {
		
				JS_prefData.pdfStyle = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
				JS_prefData.pdfPreset = JS_GetKeyValueAsStringCS(JS_prefFile.readln());
				JS_prefData.psStyle = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
				JS_prefData.psPreset = JS_GetKeyValueAsStringCS(JS_prefFile.readln());

				JS_prefData.offsetPrefix = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
				JS_prefData.namePrefix = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
				JS_prefData.contPrefix = JS_GetKeyValueAsBooleanCS(JS_prefFile.readln());
				JS_prefFile.close();
			}
			else {
			
				alert("Export Pages ID" + JS_CARR_RETURN + "Can't open Preferences File for read operations...");
				return;
			}
		}
		else {
		
			var JS_prefData = new Object;

			JS_prefData.pdfStyle = true;	
			JS_prefData.pdfPreset = app.pdfExportPresets[0].name;	
			JS_prefData.psStyle = false;
			JS_prefData.psPreset = app.printerPresets[0].name;

			JS_prefData.offsetPrefix = true;
			JS_prefData.namePrefix = false;
			JS_prefData.contPrefix = false;
	
			JS_SaveExportPagesPrefsID(JS_prefData, JS_prefFile);
		}
		
		JS_prefDlg = new Window('dialog', 'Export Pages ID Options');

		JS_prefDlg.orientation = 'column';
		JS_prefDlg.alignChildren = 'fill';

		JS_prefDlg.stylePanel = JS_prefDlg.add(JS_stylePanelID);
	
		var JS_foundIndex = -1;
		JS_prefDlg.stylePanel.pdfGrp.pdfStyle.value = JS_prefData.pdfStyle;
		for(var JS_indexI = 0; JS_indexI < app.pdfExportPresets.length; JS_indexI++) {
		
			JS_prefDlg.stylePanel.pdfGrp.pdfPreset.add('item', app.pdfExportPresets[JS_indexI].name);
			JS_pdfPresNames.push(app.pdfExportPresets[JS_indexI].name);
		
			if(JS_prefData.pdfPreset == app.pdfExportPresets[JS_indexI].name) JS_foundIndex = JS_indexI;
			else ;
		}
		if(JS_foundIndex == -1) JS_prefDlg.stylePanel.pdfGrp.pdfPreset.selection = JS_prefDlg.stylePanel.pdfGrp.pdfPreset.items[0];
		else JS_prefDlg.stylePanel.pdfGrp.pdfPreset.selection = JS_prefDlg.stylePanel.pdfGrp.pdfPreset.items[JS_foundIndex];
	
		JS_foundIndex = -1;
		JS_prefDlg.stylePanel.psGrp.psStyle.value = JS_prefData.psStyle;	
		for(JS_indexI = 0; JS_indexI < app.printerPresets.length; JS_indexI++) {
		
			JS_prefDlg.stylePanel.psGrp.psPreset.add('item', app.printerPresets[JS_indexI].name);
			JS_psPresNames.push(app.printerPresets[JS_indexI].name);
		
			if(JS_prefData.psPreset == app.printerPresets[JS_indexI].name) JS_foundIndex = JS_indexI;
			else ;
		}
		if(JS_foundIndex == -1) JS_prefDlg.stylePanel.psGrp.psPreset.selection = JS_prefDlg.stylePanel.psGrp.psPreset.items[0];
		else JS_prefDlg.stylePanel.psGrp.psPreset.selection = JS_prefDlg.stylePanel.psGrp.psPreset.items[JS_foundIndex];

		JS_prefDlg.expNamePanel = JS_prefDlg.add(JS_expNamePanelID);
	
		JS_prefDlg.expNamePanel.nameGrp.offsetBtn.value = JS_prefData.offsetPrefix;	
		JS_prefDlg.expNamePanel.nameGrp.nameBtn.value = JS_prefData.namePrefix;	
		JS_prefDlg.expNamePanel.nameGrp.contBtn.value = JS_prefData.contPrefix;	
		var JS_defName = app.activeDocument.name.split(".");
		JS_prefDlg.expNamePanel.nameGrp.nameText.text = JS_defName[0];	

		JS_prefDlg.expFolderPanel = JS_prefDlg.add(JS_expFolderPanelID);
		JS_prefDlg.expFolderPanel.folderText.text = JS_defName[0] + " Export";	


		JS_prefDlg.rangePanel = JS_prefDlg.add(JS_rangePanelID);
	
		JS_prefDlg.rangePanel.rngGrp.allBtn.value = true;	
		JS_prefDlg.rangePanel.rngGrp.rngBtn.value = false;	
		JS_prefDlg.rangePanel.rngGrp.rngText.text = "";	

		JS_prefDlg.rangePanel.rngGrp.rngText.onClick = function() {
		
															this.parent.allBtn.value = false;
															this.parent.rngBtn.value = true;
														}

		JS_prefDlg.btnGrp = JS_prefDlg.add(JS_okCancelGroupCS);
		JS_prefDlg.btnGrp.alignment = 'right';
	
		JS_prefDlg.btnGrp.cancelBtn.onClick = function() { this.parent.parent.close(0); }
		JS_prefDlg.btnGrp.okBtn.onClick = function() { this.parent.parent.close(1); }
			
		if(JS_prefDlg.show()) {
	
			if((JS_prefDlg.stylePanel.pdfGrp.pdfStyle.value)||(JS_prefDlg.stylePanel.psGrp.psStyle.value)) {
	
				for(JS_indexI = 0; JS_indexI < app.activeDocument.sections.length; JS_indexI++)
				
					app.activeDocument.sections[JS_indexI].includeSectionPrefix = true;
	
				if(JS_prefDlg.rangePanel.rngGrp.rngBtn.value) {
					
					JS_rangeList = JS_prefDlg.rangePanel.rngGrp.rngText.text.split(",");
					for(JS_indexI = 0; JS_indexI < JS_rangeList.length; JS_indexI++) {
		
						JS_rangeSpace = JS_rangeList[JS_indexI].split("-");
						if(JS_rangeSpace.length == 1) {
			
							JS_pagesInRange = app.activeDocument.pages.itemByRange(JS_rangeSpace[0], JS_rangeSpace[0]);
				
							try { 
								
								JS_nameRange.push(JS_pagesInRange.name[0]);
								JS_offsetRange.push(JS_pagesInRange.documentOffset[0]);
							}
							catch(anyError) {
								
								JS_nameRange = null;
								JS_offsetRange = null;
								break;
							}
						}
						else {
			
							if(JS_rangeSpace[0] == "") {
				
								if(JS_rangeSpace[1] == "") {
									
									JS_nameRange = null;
									JS_offsetRange = null;
									break;
								}
								else JS_rangeSpace[0] = app.activeDocument.pages[0].name;
							}
							else {
				
								if(JS_rangeSpace[1] == "") JS_rangeSpace[1] = app.activeDocument.pages[app.activeDocument.pages.length - 1].name;
								else ;
							}
							JS_pagesInRange = app.activeDocument.pages.itemByRange(JS_rangeSpace[0], JS_rangeSpace[1]);
				
							try {
								
								for(JS_indexJ = 0; JS_indexJ < JS_pagesInRange.name.length; JS_indexJ++) {
									
									JS_nameRange.push(JS_pagesInRange.name[JS_indexJ]);
									JS_offsetRange.push(JS_pagesInRange.documentOffset[JS_indexJ]);
								}
							}
							catch(anyError) {
								
								JS_nameRange = null;
								JS_offsetRange = null;
								break;
							}
						}
					}
				}
				else {
					
					for(JS_indexI = 0; JS_indexI < app.activeDocument.pages.length; JS_indexI++) {
		
						JS_nameRange.push(app.activeDocument.pages[JS_indexI].name);
						JS_offsetRange.push(app.activeDocument.pages[JS_indexI].documentOffset);
					}
				}
			
				if((JS_nameRange)&&(JS_offsetRange)) {
				
					JS_prefData.pdfStyle = JS_prefDlg.stylePanel.pdfGrp.pdfStyle.value;
					JS_prefData.pdfPreset = JS_pdfPresNames[parseInt(JS_prefDlg.stylePanel.pdfGrp.pdfPreset.selection)];
						
					JS_prefData.psStyle = JS_prefDlg.stylePanel.psGrp.psStyle.value;
					JS_prefData.psPreset = JS_psPresNames[parseInt(JS_prefDlg.stylePanel.psGrp.psPreset.selection)];
				
					JS_prefData.offsetPrefix = JS_prefDlg.expNamePanel.nameGrp.offsetBtn.value;	
					JS_prefData.namePrefix = JS_prefDlg.expNamePanel.nameGrp.nameBtn.value;	
					JS_prefData.contPrefix = JS_prefDlg.expNamePanel.nameGrp.contBtn.value;	
				
					JS_SaveExportPagesPrefsID(JS_prefData, JS_prefFile);

					var JS_exportFolder = new Folder(app.activeDocument.fullName.parent + "/" + JS_prefDlg.expFolderPanel.folderText.text);
			
					if(JS_exportFolder.exists) ;
					else JS_exportFolder.create();
			
					if(JS_exportFolder) {
			
						if(JS_prefData.pdfStyle) {
			
							var JS_pdfPreset = app.pdfExportPresets.item(JS_prefData.pdfPreset);
							for(JS_indexI = 0; JS_indexI < JS_nameRange.length; JS_indexI++) {

								JS_namePrefix = JS_GetNamePrefixID(JS_prefData, JS_offsetRange[JS_indexI], JS_nameRange[JS_indexI], JS_indexI);
								JS_exportFile = new File(JS_exportFolder.fsName + "/" + JS_namePrefix + " " + JS_prefDlg.expNamePanel.nameGrp.nameText.text + ".pdf");
								
								app.pdfExportPreferences.pageRange = String(JS_nameRange[JS_indexI]);
								app.activeDocument.exportFile(ExportFormat.pdfType, JS_exportFile, false, JS_pdfPreset);
							}
							if(JS_prefData.psStyle) {

								var JS_psPreset = app.printerPresets.item(JS_prefData.psPreset);
								for(JS_indexI = 0; JS_indexI < JS_nameRange.length; JS_indexI++) {
				
									JS_namePrefix = JS_GetNamePrefixID(JS_prefData, JS_offsetRange[JS_indexI], JS_nameRange[JS_indexI], JS_indexI);
									JS_psPreset.printFile = new File(JS_exportFolder.fsName + "/" + JS_namePrefix + " " + JS_prefDlg.expNamePanel.nameGrp.nameText.text + ".ps");
									
									app.activeDocument.printPreferences.pageRange = String(JS_nameRange[JS_indexI]);
									app.activeDocument.print(false, JS_psPreset);
								}
							}
							else ;
						}
						else {
			
							var JS_psPreset = app.printerPresets.item(JS_prefData.psPreset);
							for(JS_indexI = 0; JS_indexI < JS_nameRange.length; JS_indexI++) {
				
								JS_namePrefix = JS_GetNamePrefixID(JS_prefData, JS_offsetRange[JS_indexI], JS_nameRange[JS_indexI], JS_indexI);
								JS_psPreset.printFile = new File(JS_exportFolder.fsName + "/" + JS_namePrefix + " " + JS_prefDlg.expNamePanel.nameGrp.nameText.text + ".ps");
								
								app.activeDocument.printPreferences.pageRange = String(JS_nameRange[JS_indexI]);
								app.activeDocument.print(false, JS_psPreset);
							}
						}
					}
					else alert("Export Pages ID" + "\r" + "YES! Fuck this export! Long Live Rock'N'Roll!!!");
				}
				else alert("Export Pages ID" + "\r" + "Incorrect Page Range specification...");
			}
			else alert("Export Pages ID" + "\r" + "Neither PDF nor PS Export is selected...");
		}
		else return;
	}
	else alert("Export Pages ID" + "\r" + "Please open a document and try again...");
}

main();
